package come.stormborntales.notevault.data.repository

import come.stormborntales.notevault.data.local.dao.CollectionDao
import come.stormborntales.notevault.data.local.dao.NoteDao
import come.stormborntales.notevault.data.local.entity.NoteCollection
import come.stormborntales.notevault.data.local.entity.NoteEntity
import kotlinx.coroutines.flow.Flow


class CollectionRepository(private val dao: CollectionDao) {
    fun getCollectionsByParent(parentId: Int?): Flow<List<NoteCollection>> {
        return dao.getCollectionsByParent(parentId)
    }

    suspend fun insertCollection(collection: NoteCollection) {
        dao.insertCollection(collection)
    }

    suspend fun updateCollection(collection: NoteCollection) {
        dao.updateCollection(collection)
    }

    suspend fun deleteCollection(collection: NoteCollection) {
        dao.deleteCollection(collection)
    }

    suspend fun getCollectionById(id: Int): NoteCollection? {
        return dao.getById(id)
    }

    fun getAllCollections(): Flow<List<NoteCollection>> {
        return dao.getAll()
    }
}